<?php 
defined('BASEPATH') OR exit('No direct script access allowed');

class Synchronization extends CI_Controller
{
	public function index()
	{

	}


	public function getReseravtionFromLog($month = 0){

		$reservations = $this->ReservationsModel->getReservationFromLog($month);

		foreach ($reservations as $key => $reservation) {

			$reservation_json = json_decode($reservation['request']);	

			if(isset($reservation_json->hr_number)){

				$currency = isset($reservation_json->currency) ? $reservation_json->currency : 'EUR' ;

				$taux = $this->ReservationsModel->getDeviseBase($currency,false);

				$reason = isset($reservation_json->reason) ? $reservation_json->reason : '' ;

				$provider_number = isset($reservation_json->provider_number) ? $reservation_json->provider_number : 0 ;	

				$nom = isset($reservation_json->guest) ? $reservation_json->guest : '' ;

				$cancel_reason = isset($reservation_json->cancel_reason) ? $reservation_json->cancel_reason : '' ;

				$note = isset($reservation_json->note) ? $reservation_json->note : '' ;

				$ville = isset($reservation_json->address->city) ? $reservation_json->address->city : '' ;
				$idPays = isset($reservation_json->address->country_code) ? $reservation_json->address->country_code : 'NN' ;
				$tel = isset($reservation_json->address->phone) ? $reservation_json->address->phone : '' ;
				$email = isset($reservation_json->address->email) ? $reservation_json->address->email : '@' ;
				$adresse = isset($reservation_json->address->street) ? $reservation_json->address->street : '' ;
				$adresse .= isset($reservation_json->address->street_2) ? $reservation_json->address->street_2 : '' ;


				$idCardex = $this->ReservationsModel->insertCardex($adresse,$ville,$idPays,$email,$tel,$nom);

				$canceled = ($reservation_json->state == 'canceled') ? 1 : 0;

				$total_guests=isset($reservation_json->total_guests) ? $reservation_json->total_guests : 0 ;
				$total_rooms=isset($reservation_json->total_rooms) ? $reservation_json->total_rooms : 0 ;
				$guest_national_id=isset($reservation_json->guest_national_id) ? $reservation_json->guest_national_id : '' ;
				$message_uid=isset($reservation_json->message_uid) ? $reservation_json->message_uid : '' ;
				$source_display=isset($reservation_json->source_display) ? $reservation_json->source_display : '' ;

				if($this->ReservationsModel->insertReservationHR($reservation_json->hr_number,$provider_number, $reservation_json->channel,$reservation_json->channel_display,$reason,$reservation_json->state,$reservation_json->modified,$nom,$cancel_reason,$reservation_json->sub_total,$reservation_json->extras_total,$reservation_json->adjustments_total,$reservation_json->tax_total,$reservation_json->total,$currency,$note,$reservation_json->checkin_date,$reservation_json->checkout_date,$reservation_json->payment,$reservation_json->paid_amount,$reservation_json->completed_at,$reservation_json->updated_at,$idCardex,$total_guests,$total_rooms,$guest_national_id,$message_uid,$source_display,$taux,$canceled,$reservation_json->rooms)){

					print json_encode(array('status' => "ok"));

				}
		
			}
		}

	}



	public function getRoomTypeList(){

		$token = 'pxPam45IjpGGH58AgWLjN1WW1WHDT0mtx1XEVmeM';
		$id_HR = '341486717';

		     //  Setting URL To Fetch Data From
		$this->curl->create('https://staging.hotelrunner.com/api/property/types.json');

			// To Temporarily Store Data Received From Server
			$this->curl->option('buffersize', 10);
			//  To support Different Browsers
			$this->curl->option('useragent', 'Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.2.8) Gecko/20100722 Firefox/3.6.8 (.NET CLR 3.5.30729)');
			//  To Receive Data Returned From Server
			$this->curl->option('returntransfer', 1);
			//  To follow The URL Provided For Website
			$this->curl->option('followlocation', 1);
			//   To Retrieve Server Related Data
			//$this->curl->option('HEADER', true);
			//  To Set Time For Process Timeout
			$this->curl->option('connecttimeout', 600);

			$json = $this->curl->execute();

			$http_code = $this->curl->info['http_code'];
			var_dump($json);

         
			if(!$this->curl->error_code){
				$channels = json_decode($json);

				foreach ($channels->channels as $key => $channel) {
					echo '<br><br><br><span style="color:red">room '.$channel->name.'</span>';

					$this->ChannelsModel->insert($channel->code,$channel->name);
					//var_dump($room);
				}
				
			}

	}


	public function getChannels(){

		$token = 'pxPam45IjpGGH58AgWLjN1WW1WHDT0mtx1XEVmeM';
		$id_HR = '341486717';

		     //  Setting URL To Fetch Data From
		$this->curl->create('https://app.hotelrunner.com/api/v1/apps/infos/channels?token='.$token.'&hr_id='.$id_HR);

			// To Temporarily Store Data Received From Server
			$this->curl->option('buffersize', 10);
			//  To support Different Browsers
			$this->curl->option('useragent', 'Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.2.8) Gecko/20100722 Firefox/3.6.8 (.NET CLR 3.5.30729)');
			//  To Receive Data Returned From Server
			$this->curl->option('returntransfer', 1);
			//  To follow The URL Provided For Website
			$this->curl->option('followlocation', 1);
			//   To Retrieve Server Related Data
			//$this->curl->option('HEADER', true);
			//  To Set Time For Process Timeout
			$this->curl->option('connecttimeout', 600);

			$json = $this->curl->execute();

			$http_code = $this->curl->info['http_code'];

         
			if(!$this->curl->error_code){
				$channels = json_decode($json);

				foreach ($channels->channels as $key => $channel) {
					echo '<br><br><br><span style="color:red">room '.$channel->name.'</span>';

					$this->ChannelsModel->insert($channel->code,$channel->name);
					//var_dump($room);
				}
				
			}
	}




	public function getListRooms(){

		$token = 'pxPam45IjpGGH58AgWLjN1WW1WHDT0mtx1XEVmeM';
		$id_HR = '341486717';

		//  Setting URL To Fetch Data From
		$this->curl->create('https://app.hotelrunner.com/api/v2/apps/rooms?token='.$token.'&hr_id='.$id_HR);
		// To Temporarily Store Data Received From Server
		$this->curl->option('buffersize', 10);
		//  To support Different Browsers
		$this->curl->option('useragent', 'Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.2.8) Gecko/20100722 Firefox/3.6.8 (.NET CLR 3.5.30729)');
		//  To Receive Data Returned From Server
		$this->curl->option('returntransfer', 1);
		//  To follow The URL Provided For Website
		$this->curl->option('followlocation', 1);
		//   To Retrieve Server Related Data
		//$this->curl->option('HEADER', true);
		//  To Set Time For Process Timeout
		$this->curl->option('connecttimeout', 800);

		$json = $this->curl->execute();

		$http_code = $this->curl->info['http_code'];
         
		if(!$this->curl->error_code){
			 // header('Content-Type: application/json');
			 // echo $json;die;

			$rooms = json_decode($json);
			//var_dump($json);
			$i=0;
			foreach ($rooms->rooms as $key => $room) {
		 

				$insert_data[$i]['name'] = $room->name;
				$insert_data[$i]['description'] = $room->description;
				$insert_data[$i]['capacite'] = $room->room_capacity;
				$insert_data[$i]['adult'] = $room->adult_capacity;
				$insert_data[$i]['code'] = $room->code;
				$insert_data[$i]['inv_code'] = $room->inv_code;
				$insert_data[$i]['availabilityUpdate'] = $room->availability_update;
				$insert_data[$i]['restrictionsUpdate'] = $room->restrictions_update;
				$insert_data[$i]['priceUpdate'] = $room->price_update;
				$insert_data[$i]['rate_plan_code'] = $room->rate_plan_code;
				$insert_data[$i]['pricing_type '] = $room->pricing_type;
				$insert_data[$i]['rate_code'] = $room->rate_code;
				$insert_data[$i]['rate_plan_code'] = $room->rate_plan_code;
				$insert_data[$i]['idChannelChambre'] = $room->inv_code;
				$insert_data[$i]['idChannelTarif'] = $room->rate_plan_code;
             	$i++;



			}

			$this->ChambresModel->insertHRChambreTarif($insert_data);
				
		}

	}

}